import caches
import pprint

MAX_BLOCK_SIZE = 32 # block size is always a power of 2
MAX_CACHE_SIZE = 2 ** 16 # cache size is always a power of 2
MAX_ASSOC = 8 # associativity is always a power of 2
MAX_VBUFFER_SIZE = 6 # victim buffer size is just a natural number

def find_block_size( cache ):
    """Returns block size (in bytes) of the cache."""
    cache.reset()
    # TODO: your code here

def find_cache_size( cache, block_size ):
    """Returns total size (in bytes) of the cache."""
    cache.reset()
    # TODO: your code here

def find_associativity( cache, size, block_size ):
    """Returns associativity of the cache for a cache without a
    victim buffer.
    """
    assert not cache.has_victim_buffer()
    cache.reset()
    # TODO: your code here

def find_victim_buffer_size( cache, size, block_size ):
    """Returns a tuple of (associativity,victim buffer size) for a
    cache with a victim buffer.
    """
    assert cache.has_victim_buffer()
    cache.reset()
    # TODO: your code here

def main(cache):
    answers = {}

    block_size = find_block_size(cache)
    answers['block size'] = block_size

    size = find_cache_size(cache, block_size)
    answers['cache size'] = size

    if cache.has_victim_buffer():
        assoc,vb_size = find_victim_buffer_size(cache, size, block_size)
        answers['victim buffer size'] = vb_size
        answers['associativity'] = assoc
    else:
        answers['associativity'] = find_associativity(cache, size, block_size)

    return answers

if __name__ == "__main__":
    # test your code by creating different caches here
    cache = caches.Cache( bsize=2, assoc=4, size=64, vbsize=None )
    #cache = caches.Cache( bsize=2, assoc=1, size=64, vbsize=None ) # direct-mapped
    #cache = caches.Cache( bsize=2, assoc=4, size=8, vbsize=None ) # fully-associative
    #cache = caches.Cache( bsize=4, assoc=2, size=16, vbsize=1 ) # victim buffer
    #cache = caches.Cache( bsize=4, assoc=1, size=16, vbsize=1 ) # direct-mapped + victim buffer

    pprint.pprint(main(cache))
